#include <math.h>
#include <malloc.h>
#include "bezier.h"

// La procdure de calcul d'une courbe de bzier avec l'algorithme de De Casteljeau
Table_triplet calcul_courbe_bezier(Table_triplet Tab_pt_controle, int nb_point) {
	
	// La liste de triplet rsultat de l'algorithme
	Table_triplet liste;
	
	// le tableau dans lequel on fait chaque tape de De Casteljeau	
	Table_triplet tmp;
	
	// Une variable pour recopier les tableaux
	int truc;
	
	int iter = 0;
	int num_pt_ctrl = 0;
	int num_pt = 0;
	double t = 0.0;

	liste.nb = nb_point;
	tmp.nb = Tab_pt_controle.nb;
	liste.table = (Triplet *) malloc(sizeof(Triplet) * nb_point);
	tmp.table = (Triplet *) malloc(sizeof(Triplet) * Tab_pt_controle.nb);
	
	// Pour chaque point de discrtisation
	for (num_pt = 0; num_pt < nb_point; num_pt++) {
		//Calcul de t
		t = ((double)num_pt)/((double)nb_point-1); 
		
		//On sauvegarde Tab_pt_controle (memcpy ne fonctionne pas on sait pas pourkoi)
		/*memcpy(tmp.table, Tab_pt_controle.table, Tab_pt_controle.nb);*/
		for (truc = 0; truc < Tab_pt_controle.nb; truc++) {
			tmp.table[truc].x = Tab_pt_controle.table[truc].x;
			tmp.table[truc].y = Tab_pt_controle.table[truc].y;
			tmp.table[truc].z = Tab_pt_controle.table[truc].z;
		}
	
		// La boucle de droulement de l'algorithme de De Casteljeau pour un t 
		for (iter = 0; iter < tmp.nb; iter++) {
			for (num_pt_ctrl = 0; num_pt_ctrl < (tmp.nb-iter-1);num_pt_ctrl++) {
				tmp.table[num_pt_ctrl].x = tmp.table[num_pt_ctrl].x * (1.0-t) +
				                         tmp.table[num_pt_ctrl+1].x * (t);
				tmp.table[num_pt_ctrl].y = tmp.table[num_pt_ctrl].y * (1.0-t) +
				                         tmp.table[num_pt_ctrl+1].y * (t);
				tmp.table[num_pt_ctrl].z = tmp.table[num_pt_ctrl].z * (1.0-t) +
				                         tmp.table[num_pt_ctrl+1].z * (t);
			}
		}
		
		// On enregistre la dernire valeur dans la liste rsultat
		liste.table[num_pt].x = tmp.table[0].x; 
		liste.table[num_pt].y = tmp.table[0].y;
		liste.table[num_pt].z = tmp.table[0].z;
	}
	
	// On libre la mmoire
	free(tmp.table);

	return liste;
} 
