#include <math.h>
#include <malloc.h>

typedef struct Triplet
{
   float x, y, z;
} Triplet;


typedef struct Table_triplet
{
   Triplet *table;
   int nb;
} Table_triplet;

typedef struct Grille_triplet
{
   Triplet **grille;
   int nb_colonnes;
   int nb_lignes;
} Grille_triplet;

// La structure qui stocke les valeurs de la courbe d'interpolation
typedef struct patch_bezier 
{
  Grille_triplet gr_cont;
  Grille_triplet gr_result;
  Grille_triplet gr_derivee; 
  
  int nb_pt_u;
  int nb_pt_v;
  bool affiche_pt_ctrl; // 1 -> affiche le polygone de controle 0 sinon
  bool affiche_vect_derive;
} patch_bezier;

// La procdure de calcul d'une courbe de bzier avec l'algorithme de De Casteljeau
// Cette procdure alloue une tablea_triplet qui contient tous les points de la
// courbe rsultat.
extern "C" {Table_triplet calcul_courbe_bezier(Table_triplet Tab_pt_controle, int nb_point);}
extern "C" {Grille_triplet calcul_patch_bezier(Grille_triplet Tab_pt_controle, int nb_point_u, int nb_point_v); }
extern "C" {void affiche_patch_bezier(struct patch_bezier *o, float blend); }
extern "C" {void changement(struct patch_bezier *o); }

